Обновлены ебилды vmware.

vmware-308.1.1 теперь работает и с ядрами >= 4.10
rasdark
rasdark 7 years ago
parent 561397a9b6
commit 94a16f5913

@ -4,81 +4,65 @@
int retval;
down_read(&current->mm->mmap_sem);
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 5, 99)
+ retval = get_user_pages(addr,
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 6, 0)
+ retval = get_user_pages(addr, 1, 1, 0, &page, NULL);
+#else
retval = get_user_pages(current, current->mm, addr,
+#endif
1, 1, 0, &page, NULL);
+#endif
up_read(&current->mm->mmap_sem);
--- ./vmci-only/linux/vmciKernelIf.c.old 2016-05-19 18:57:04.344658673 +0200
+++ ./vmci-only/linux/vmciKernelIf.c 2016-05-19 19:03:28.600680159 +0200
@@ -1835,7 +1835,11 @@
if (dirty) {
set_page_dirty(pages[i]);
}
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 5, 99)
+ put_page(pages[i]);
+#else
page_cache_release(pages[i]);
+#endif
pages[i] = NULL;
}
}
@@ -2049,9 +2053,13 @@
@@ -2049,6 +2049,13 @@
int err = VMCI_SUCCESS;
down_write(&current->mm->mmap_sem);
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 5, 99)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 6, 0)
+ retval = get_user_pages((VA)produceUVA,
+ produceQ->kernelIf->numPages,
+ 1, 0,
+ produceQ->kernelIf->u.h.headerPage,
+ NULL);
+#else
retval = get_user_pages(current,
current->mm,
(VA)produceUVA,
+#endif
produceQ->kernelIf->numPages,
@@ -2056,6 +2063,7 @@
1, 0,
produceQ->kernelIf->u.h.headerPage,
@@ -2063,9 +2071,13 @@
goto out;
}
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 5, 99)
+ retval = get_user_pages((VA)consumeUVA,
+#else
retval = get_user_pages(current,
current->mm,
(VA)consumeUVA,
NULL);
+#endif
consumeQ->kernelIf->numPages,
1, 0,
consumeQ->kernelIf->u.h.headerPage,
if (retval < produceQ->kernelIf->numPages) {
Log("get_user_pages(produce) failed (retval=%d)\n", retval);
VMCIReleasePages(produceQ->kernelIf->u.h.headerPage, retval, FALSE);
--- ./vmmon-only/linux/hostif.c.old 2016-05-19 18:50:42.872637343 +0200
+++ ./vmmon-only/linux/hostif.c 2016-05-19 18:53:40.208647259 +0200
@@ -1163,7 +1163,11 @@
int retval;
down_read(&current->mm->mmap_sem);
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 5, 99)
+ retval = get_user_pages((unsigned long)uvAddr,
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 6, 0)
+ retval = get_user_pages((unsigned long)uvAddr, numPages, 0, 0, ppages, NULL);
+#else
retval = get_user_pages(current, current->mm, (unsigned long)uvAddr,
+#endif
numPages, 0, 0, ppages, NULL);
+#endif
up_read(&current->mm->mmap_sem);
--- ./vmnet-only/userif.c.old 2016-05-19 18:52:45.904644222 +0200
+++ ./vmnet-only/userif.c 2016-05-19 18:53:28.599646610 +0200
@@ -113,7 +113,11 @@
@@ -113,8 +113,12 @@
int retval;
down_read(&current->mm->mmap_sem);
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 5, 99)
+ retval = get_user_pages(addr,
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 6, 0)
+ retval = get_user_pages(addr, 1, 1, 0, &page, NULL);
+#else
retval = get_user_pages(current, current->mm, addr,
- 1, 1, 0, &page, NULL);
+ 1, 1, 0, &page, NULL);
+#endif
1, 1, 0, &page, NULL);
up_read(&current->mm->mmap_sem);
if (retval != 1) {

@ -0,0 +1,28 @@
--- ./vmci-only/linux/vmciKernelIf.c.old 2016-05-19 18:57:04.344658673 +0200
+++ ./vmci-only/linux/vmciKernelIf.c 2016-05-19 19:03:28.600680159 +0200
@@ -1835,7 +1835,11 @@
if (dirty) {
set_page_dirty(pages[i]);
}
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 5, 99)
+ put_page(pages[i]);
+#else
page_cache_release(pages[i]);
+#endif
pages[i] = NULL;
}
}
@@ -2063,9 +2067,13 @@
goto out;
}
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 5, 99)
+ retval = get_user_pages((VA)consumeUVA,
+#else
retval = get_user_pages(current,
current->mm,
(VA)consumeUVA,
+#endif
consumeQ->kernelIf->numPages,
1, 0,
consumeQ->kernelIf->u.h.headerPage,

@ -0,0 +1,39 @@
--- ./vmci-only/linux/vmciKernelIf.c 2017-02-23 12:19:59.706822502 +0100
+++ ./vmci-only/linux/vmciKernelIf.c.new 2017-02-23 13:12:09.382997502 +0100
@@ -2056,7 +2056,11 @@
#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 6, 0)
retval = get_user_pages((VA)produceUVA,
produceQ->kernelIf->numPages,
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 9, 0)
+ FOLL_WRITE,
+#else
1, 0,
+#endif
produceQ->kernelIf->u.h.headerPage,
NULL);
#else
@@ -2083,7 +2087,11 @@
(VA)consumeUVA,
#endif
consumeQ->kernelIf->numPages,
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 9, 0)
+ FOLL_WRITE,
+#else
1, 0,
+#endif
consumeQ->kernelIf->u.h.headerPage,
NULL);
if (retval < consumeQ->kernelIf->numPages) {
--- ./vmci-only/linux/driver.c 2017-02-23 12:19:59.645822499 +0100
+++ ./vmci-only/linux/driver.c.new 2017-02-23 12:30:38.845858240 +0100
@@ -1468,7 +1468,9 @@
int retval;
down_read(&current->mm->mmap_sem);
-#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 6, 0)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 9, 0)
+ retval = get_user_pages(addr, 1, FOLL_WRITE, &page, NULL);
+#elif LINUX_VERSION_CODE >= KERNEL_VERSION(4, 6, 0)
retval = get_user_pages(addr, 1, 1, 0, &page, NULL);
#else
retval = get_user_pages(current, current->mm, addr,

@ -0,0 +1,26 @@
--- ./vmnet-only/userif.c 2017-02-23 12:29:00.909852764 +0100
+++ ./vmnet-only/userif.c.new 2017-02-23 12:28:51.309852227 +0100
@@ -113,7 +113,9 @@
int retval;
down_read(&current->mm->mmap_sem);
-#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 6, 0)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 9, 0)
+ retval = get_user_pages(addr, 1, FOLL_WRITE, &page, NULL);
+#elif LINUX_VERSION_CODE >= KERNEL_VERSION(4, 6, 0)
retval = get_user_pages(addr, 1, 1, 0, &page, NULL);
#else
retval = get_user_pages(current, current->mm, addr,
--- ./vmmon-only/linux/hostif.c 2017-02-23 12:19:59.772822506 +0100
+++ ./vmmon-only/linux/hostif.c.new 2017-02-23 12:26:42.661845034 +0100
@@ -1167,7 +1167,9 @@
int retval;
down_read(&current->mm->mmap_sem);
-#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 6, 0)
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 9, 0)
+ retval = get_user_pages((unsigned long)uvAddr, numPages, 0, ppages, NULL);
+#elif LINUX_VERSION_CODE >= KERNEL_VERSION(4, 6, 0)
retval = get_user_pages((unsigned long)uvAddr, numPages, 0, 0, ppages, NULL);
#else
retval = get_user_pages(current, current->mm, (unsigned long)uvAddr,

@ -1,77 +0,0 @@
--- vmmon-only/linux/hostif.c 2016-12-12 09:17:44.438182532 -0700
+++ vmmon-only/linux/hostif.c 2016-12-12 09:19:24.066254301 -0700
@@ -1172,7 +1172,11 @@
#else
retval = get_user_pages(current, current->mm, (unsigned long)uvAddr,
#endif
- numPages, 0, 0, ppages, NULL);
+ numPages, 0,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4, 9, 0)
+ 0,
+#endif
+ ppages, NULL);
up_read(&current->mm->mmap_sem);
return retval != numPages;
--- vmnet-only/userif.c 2016-12-12 09:27:12.445246854 -0700
+++ vmnet-only/userif.c 2016-12-12 09:27:30.654298646 -0700
@@ -118,7 +118,13 @@
#else
retval = get_user_pages(current, current->mm, addr,
#endif
- 1, 1, 0, &page, NULL);
+ 1,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4, 9, 0)
+ 1, 0,
+#else
+ FOLL_WRITE,
+#endif
+ &page, NULL);
up_read(&current->mm->mmap_sem);
if (retval != 1) {
--- vmci-only/linux/driver.c 2016-12-12 09:38:13.076847013 -0700
+++ vmci-only/linux/driver.c 2016-12-12 09:38:45.638087445 -0700
@@ -1473,7 +1473,13 @@
#else
retval = get_user_pages(current, current->mm, addr,
#endif
- 1, 1, 0, &page, NULL);
+ 1,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4, 9, 0)
+ 1, 0,
+#else
+ FOLL_WRITE,
+#endif
+ &page, NULL);
up_read(&current->mm->mmap_sem);
if (retval != 1) {
--- vmci-only/linux/vmciKernelIf.c 2016-12-12 09:38:20.678904322 -0700
+++ vmci-only/linux/vmciKernelIf.c 2016-12-12 09:39:59.129587451 -0700
@@ -2061,7 +2061,11 @@
(VA)produceUVA,
#endif
produceQ->kernelIf->numPages,
- 1, 0,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4, 9, 0)
+ 1, 0,
+#else
+ FOLL_WRITE,
+#endif
produceQ->kernelIf->u.h.headerPage,
NULL);
if (retval < produceQ->kernelIf->numPages) {
@@ -2079,7 +2083,11 @@
(VA)consumeUVA,
#endif
consumeQ->kernelIf->numPages,
- 1, 0,
+#if LINUX_VERSION_CODE < KERNEL_VERSION(4, 9, 0)
+ 1, 0,
+#else
+ FOLL_WRITE,
+#endif
consumeQ->kernelIf->u.h.headerPage,
NULL);
if (retval < consumeQ->kernelIf->numPages) {

@ -0,0 +1,14 @@
--- vmblock-only/linux/inode.c 2017-02-21 08:38:50.844678686 -0700
+++ vmblock-only/linux/inode.c 2017-02-21 08:59:40.557917497 -0700
@@ -207,8 +207,10 @@
return vfs_readlink(dentry, buffer, buflen, iinfo->name);
#elif LINUX_VERSION_CODE <= KERNEL_VERSION(4, 6, 99)
return readlink_copy(buffer, buflen, iinfo->name);
-#else
+#elif LINUX_VERSION_CODE <= KERNEL_VERSION(4, 9, 99)
return generic_readlink(dentry, buffer, buflen);
+#else
+ return vfs_readlink(dentry, buffer, buflen);
#endif
}

@ -0,0 +1,40 @@
--- vmblock-only/linux/inode.c 2017-05-06 16:54:57.000000000 +0200
+++ vmblock-only/linux/inode.c.new 2017-05-06 16:55:32.000000000 +0200
@@ -28,6 +28,7 @@
#include <linux/fs.h>
#include <linux/time.h>
#include <linux/namei.h>
+#include <linux/cred.h>
#include "vmblockInt.h"
#include "filesystem.h"
--- vmci-only/linux/driver.c 2017-05-06 16:59:06.000000000 +0200
+++ vmci-only/linux/driver.c.new 2017-05-06 17:00:03.000000000 +0200
@@ -38,6 +38,7 @@
#include <linux/poll.h>
#include <linux/smp.h>
#include <linux/vmalloc.h>
+#include <linux/cred.h>
#include "compat_highmem.h"
#include "compat_interrupt.h"
--- vmci-only/linux/vmciKernelIf.c 2017-05-06 17:00:42.000000000 +0200
+++ vmci-only/linux/vmciKernelIf.c.new 2017-05-06 17:01:24.000000000 +0200
@@ -41,6 +41,7 @@
#include <linux/vmalloc.h>
#include <linux/wait.h>
#include <linux/skbuff.h>
+#include <linux/sched/signal.h>
#include "compat_highmem.h"
#include "compat_interrupt.h"
--- vsock-only/linux/af_vsock.c 2017-05-06 17:02:05.000000000 +0200
+++ vsock-only/linux/af_vsock.c.new 2017-05-06 17:02:49.000000000 +0200
@@ -106,6 +106,7 @@
#include <linux/list.h>
#include <linux/wait.h>
#include <linux/init.h>
+#include <linux/sched/signal.h>
#include <asm/io.h>
#if defined(__x86_64__) && LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 12)
# include <linux/ioctl32.h>

@ -0,0 +1,20 @@
--- vmmon-only/linux/hostif.c 2017-05-06 16:56:09.000000000 +0200
+++ vmmon-only/linux/hostif.c.new 2017-05-06 16:56:41.000000000 +0200
@@ -73,6 +73,7 @@
#include <linux/capability.h>
#include <linux/kthread.h>
#include <linux/wait.h>
+#include <linux/sched/signal.h>
#include <asm/apic.h>
--- vmnet-only/userif.c 2017-03-13 04:05:59.000000000 +0100
+++ vmnet-only/userif.c.new 2017-05-06 16:58:32.000000000 +0200
@@ -36,6 +36,7 @@
#include <linux/slab.h>
#include <linux/version.h>
#include <linux/wait.h>
+#include <linux/sched/signal.h>
#include <net/checksum.h>
#include <net/sock.h>

@ -0,0 +1,21 @@
--- vsock-only/linux/af_vsock.c 2017-05-21 00:58:02.900776185 +0200
+++ vsock-only/linux/af_vsock.c.new 2017-05-21 00:57:18.932773727 +0200
@@ -213,7 +213,7 @@
struct sockaddr *addr, int addrLen, int flags);
static int VSockVmciStreamConnect(struct socket *sock,
struct sockaddr *addr, int addrLen, int flags);
-static int VSockVmciAccept(struct socket *sock, struct socket *newsock, int flags);
+static int VSockVmciAccept(struct socket *sock, struct socket *newsock, int flags, bool kern);
static int VSockVmciGetname(struct socket *sock,
struct sockaddr *addr, int *addrLen, int peer);
static unsigned int VSockVmciPoll(struct file *file,
@@ -3772,7 +3772,8 @@
static int
VSockVmciAccept(struct socket *sock, // IN
struct socket *newsock, // IN/OUT
- int flags) // IN
+ int flags, // IN
+ bool kern) // IN
{
struct sock *listener;
int err;

@ -0,0 +1,30 @@
diff -ur old/vmmon-only/linux/driver.c vmmon-only/linux/driver.c
--- old/vmmon-only/linux/driver.c 2016-11-12 09:15:52.000000000 +0200
+++ vmmon-only/linux/driver.c 2017-03-06 10:46:33.347053458 +0200
@@ -105,7 +105,7 @@
static int LinuxDriver_Close(struct inode *inode, struct file *filp);
static unsigned int LinuxDriverPoll(struct file *file, poll_table *wait);
#if defined(VMW_NOPAGE_2624)
-static int LinuxDriverFault(struct vm_area_struct *vma, struct vm_fault *fault);
+static int LinuxDriverFault(struct vm_fault *fault);
#else
static struct page *LinuxDriverNoPage(struct vm_area_struct *vma,
unsigned long address,
@@ -882,15 +882,14 @@
*/
#if defined(VMW_NOPAGE_2624)
-static int LinuxDriverFault(struct vm_area_struct *vma, //IN
- struct vm_fault *fault) //IN/OUT
+static int LinuxDriverFault(struct vm_fault *fault) //IN/OUT
#else
static struct page *LinuxDriverNoPage(struct vm_area_struct *vma, //IN
unsigned long address, //IN
int *type) //OUT: Fault type
#endif
{
- VMLinux *vmLinux = (VMLinux *) vma->vm_file->private_data;
+ VMLinux *vmLinux = (VMLinux *) fault->vma->vm_file->private_data;
unsigned long pg;
struct page* page;

@ -0,0 +1,162 @@
# Copyright 1999-2016 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Id$
EAPI=5
inherit eutils flag-o-matic linux-info linux-mod user versionator udev
PV_MAJOR=$(get_major_version)
PV_MINOR=$(get_version_component_range 2-3)
DESCRIPTION="VMware kernel modules"
HOMEPAGE="http://www.vmware.com/"
SRC_URI=""
LICENSE="GPL-2"
SLOT="0"
KEYWORDS="~amd64"
IUSE="pax_kernel +vmci +vsock"
REQUIRED_USE="!vsock? ( !vmci )"
RDEPEND=""
DEPEND="${RDEPEND}
|| ( =app-emulation/vmware-player-12.${PV_MINOR}*
=app-emulation/vmware-workstation-12.${PV_MINOR}* )"
S=${WORKDIR}
pkg_setup() {
CONFIG_CHECK="~HIGH_RES_TIMERS"
if kernel_is ge 2 6 37 && kernel_is lt 2 6 39; then
CONFIG_CHECK="${CONFIG_CHECK} BKL"
fi
if use vmci ; then
CONFIG_CHECK="${CONFIG_CHECK} !VMWARE_VMCI"
else
CONFIG_CHECK="${CONFIG_CHECK} VMWARE_VMCI"
fi
if use vsock ; then
CONFIG_CHECK="${CONFIG_CHECK} !VMWARE_VMCI_VSOCKETS"
else
CONFIG_CHECK="${CONFIG_CHECK} VMWARE_VMCI_VSOCKETS"
fi
linux-info_pkg_setup
linux-mod_pkg_setup
VMWARE_GROUP=${VMWARE_GROUP:-vmware}
VMWARE_MODULE_LIST_ALL="vmblock vmmon vmnet vmci vsock"
VMWARE_MODULE_LIST="vmblock vmmon vmnet"
use vmci && VMWARE_MODULE_LIST="${VMWARE_MODULE_LIST} vmci"
use vsock && VMWARE_MODULE_LIST="${VMWARE_MODULE_LIST} vsock"
VMWARE_MOD_DIR="${PN}-${PVR}"
BUILD_TARGETS="auto-build KERNEL_DIR=${KERNEL_DIR} KBUILD_OUTPUT=${KV_OUT_DIR}"
enewgroup "${VMWARE_GROUP}"
filter-flags -mfpmath=sse -mavx -mpclmul -maes
append-cflags -mno-sse # Found a problem similar to bug #492964
for mod in ${VMWARE_MODULE_LIST}; do
MODULE_NAMES="${MODULE_NAMES} ${mod}(misc:${S}/${mod}-only)"
done
}
src_unpack() {
cd "${S}"
for mod in ${VMWARE_MODULE_LIST_ALL}; do
tar -xf /opt/vmware/lib/vmware/modules/source/${mod}.tar
done
}
src_prepare() {
epatch "${FILESDIR}/${PV_MAJOR}-makefile-kernel-dir.patch"
epatch "${FILESDIR}/${PV_MAJOR}-makefile-include.patch"
epatch "${FILESDIR}/${PV_MAJOR}-netdevice.patch"
use pax_kernel && epatch "${FILESDIR}/${PV_MAJOR}-hardened.patch"
epatch "${FILESDIR}/${PV_MAJOR}-apic.patch"
kernel_is ge 3 10 0 && epatch "${FILESDIR}/${PV_MAJOR}-3.10-00-dentry.patch"
kernel_is ge 3 10 0 && epatch "${FILESDIR}/${PV_MAJOR}-3.10-01-inode.patch"
kernel_is ge 3 10 0 && epatch "${FILESDIR}/${PV_MAJOR}-3.10-02-control.patch"
kernel_is ge 3 10 0 && epatch "${FILESDIR}/${PV_MAJOR}-3.10-03-inline.patch"
kernel_is ge 3 11 0 && epatch "${FILESDIR}/${PV_MAJOR}-3.11-00-readdir.patch"
kernel_is ge 3 11 0 && epatch "${FILESDIR}/${PV_MAJOR}-3.11-01-filldir.patch"
kernel_is ge 3 15 0 && epatch "${FILESDIR}/${PV_MAJOR}-3.15-00-vsock.patch"
kernel_is ge 3 18 0 && epatch "${FILESDIR}/${PV_MAJOR}-3.18-00-version-redefined.patch"
kernel_is ge 3 19 0 && epatch "${FILESDIR}/${PV_MAJOR}-3.19-00-compat-namei.patch"
kernel_is ge 3 19 0 && epatch "${FILESDIR}/${PV_MAJOR}-3.19-02-vmblock-path.patch"
kernel_is ge 3 19 0 && epatch "${FILESDIR}/${PV_MAJOR}-3.19-04-iovec.patch"
kernel_is ge 3 19 0 && epatch "${FILESDIR}/${PV_MAJOR}-3.19-05-vmci_qpair.patch"
kernel_is ge 3 19 0 && epatch "${FILESDIR}/${PV_MAJOR}-3.19-06-vsock.patch"
kernel_is ge 3 19 0 && epatch "${FILESDIR}/${PV_MAJOR}-3.19-07-vsock.patch"
kernel_is ge 4 1 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.01-00-vsock.patch"
kernel_is ge 4 2 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.02-00-nd_set_link.patch"
kernel_is ge 4 2 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.02-01-sk_alloc.patch"
kernel_is ge 4 3 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.03-00-vmci-misc_deregister.patch"
kernel_is ge 4 5 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.05-00-vmblock-follow_link.patch"
kernel_is ge 4 6 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.06-00-user-pages-p1.patch"
kernel_is ge 4 6 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.06-00-user-pages-p2.patch"
kernel_is ge 4 7 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.07-00-trans_start.patch"
kernel_is ge 4 7 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.07-01-readlink_copy.patch"
kernel_is ge 4 8 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.08-00-nr_anon_mapped.patch"
kernel_is ge 4 9 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.09-00-user-pages-p1.patch"
kernel_is ge 4 9 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.09-00-user-pages-p2.patch"
kernel_is ge 4 10 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.10-00-generic_readlink.patch"
kernel_is ge 4 11 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.11-00-missing-headers-p1.patch"
kernel_is ge 4 11 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.11-00-missing-headers-p2.patch"
kernel_is ge 4 11 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.11-01-vsock-lockdep.patch"
kernel_is ge 4 11 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.11-02-vmmon.patch"
# Allow user patches so they can support RC kernels and whatever else
epatch_user
}
src_install() {
linux-mod_src_install
local udevrules="${T}/60-vmware.rules"
cat > "${udevrules}" <<-EOF
KERNEL=="vmci", GROUP="vmware", MODE="660"
KERNEL=="vmw_vmci", GROUP="vmware", MODE="660"
KERNEL=="vmmon", GROUP="vmware", MODE="660"
KERNEL=="vsock", GROUP="vmware", MODE="660"
EOF
udev_dorules "${udevrules}"
if ! use vmci ; then
dodir /etc/modprobe.d/
cat > "${D}"/etc/modprobe.d/vmware.conf <<-EOF
# Support for vmware vmci in kernel module
alias vmci vmw_vmci
EOF
export installed_modprobe_conf=1
fi
if ! use vsock ; then
dodir /etc/modprobe.d/
cat >> "${D}"/etc/modprobe.d/vmware.conf <<-EOF
# Support for vmware vsock in kernel module
alias vsock vmw_vsock_vmci_transport
EOF
export installed_modprobe_conf=1
fi
}
pkg_postinst() {
linux-mod_pkg_postinst
if [ "${installed_modprobe_conf}"x == "x" ] ; then
if [ -f "${ROOT}/etc/modprobe.d/vmware.conf" ] ; then
ewarn "Please check the /etc/modprobe.d/vmware.conf file and"
ewarn "possible conflicts when using vmci and/or vsock modules built"
ewarn "out of kernel"
fi
fi
}

@ -101,11 +101,13 @@ src_prepare() {
kernel_is ge 4 2 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.02-01-sk_alloc.patch"
kernel_is ge 4 3 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.03-00-vmci-misc_deregister.patch"
kernel_is ge 4 5 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.05-00-vmblock-follow_link.patch"
kernel_is ge 4 6 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.06-00-user-pages.patch"
kernel_is ge 4 7 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.07-00-trans_start.patch"
kernel_is ge 4 6 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.06-00-user-pages-p2.patch"
kernel_is ge 4 7 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.07-01-readlink_copy.patch"
kernel_is ge 4 8 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.08-00-nr_anon_mapped.patch"
kernel_is ge 4 9 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.09-00-user-pages.patch"
kernel_is ge 4 9 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.09-00-user-pages-p1.patch"
kernel_is ge 4 10 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.10-00-generic_readlink.patch"
kernel_is ge 4 11 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.11-00-missing-headers-p1.patch"
kernel_is ge 4 11 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.11-01-vsock-lockdep.patch"
# Allow user patches so they can support RC kernels and whatever else
epatch_user

@ -0,0 +1,6 @@
DIST vmware-tools-freebsd-10.1.6-5214329.x86_64.component.tar 17018880 SHA256 ec7cd266d29d058850f8911e9cedee57d0cc4a1e6023fd6d22fbb1e7dc3a481a SHA512 f9a9219d207012861120a9856726a291de2232787a8eb2f31623c48285406fdc010326cbf56e0adb513ca21d67f4ce8356e0b9923c476f0fdce29cb815aebabf WHIRLPOOL b7f0ee65c1e651b4758c8ce764370733cc33d8972c7b62674fa3ce3bc477c54c42f110f36e4a3fd8ca91e7808f0559782f90a7af9f3426bfd8d2f9045384d23f
DIST vmware-tools-linux-10.1.6-5214329.x86_64.component.tar 55818240 SHA256 1d2a18bb06ef69c2a25a0b12402fe924c0e3cd5273923045e6b6e5e7b15edd93 SHA512 9548cdebd8495837328fc95c1268bce4e98fd308368892fd407c0284376c6920685cef395b3230eddee8b797fbc0814a8cc8f18d350e2de0eb5bfc997100f8d8 WHIRLPOOL 63feea13b3537fdd375faa05a3577e08603911875e7142747943854dd226949cce9c3ef1be770f3189061c994c9bb278b455ee6ce1da8187b75cf1cda399da11
DIST vmware-tools-netware-10.1.6-5214329.x86_64.component.tar 81920 SHA256 98fdf6d2fcfc77e2e6bd5d369eb5b3269c3b6e34cac4c8cc356ebc979a431bf0 SHA512 6807e9fb9559dfd25acbb689f675e49f26753271bf0f4371ce7a5e23ee16eaf5f821ed89d39fe0475bb61d9e1e26f146d2e5229bef3a75634c3d2d03c225c3a8 WHIRLPOOL 73b10aae360d43313e405a211f244dde054e1d336398a3dada175f4c74173018b1da99b038b33146d90a841c1fe511e558f911e6700e1a0a00e95e7ca06ce181
DIST vmware-tools-solaris-10.1.6-5214329.x86_64.component.tar 16107520 SHA256 b6fdfb4d12735c68ec15139fa9b3a28d3e331397a55a99f3a72365e62de5c869 SHA512 73a349b9785fa33e12ec17dbc52a5ed7dd41e2ccebee73b9bd60767a7637e527cdd9c246e6bff9c66c648efc529d8c0d7cc16538de4f7d0d10542b6c74c66164 WHIRLPOOL ed4d66462a6ea82be750e3539ffa08d1c4e43f55390a3925223f1ea1b59d9fdee8eb1d4b8b73e15c16be9260e07887e71b0a8c42cff9d95136161a34f57b7233
DIST vmware-tools-winPre2k-10.1.6-5214329.x86_64.component.tar 11530240 SHA256 0b7098e7a00ce7d4bc3e32a0b6440d2bedbed15d2692c9bbd0e431da88f78ee9 SHA512 8ec328019380da0a967404e35230f192d30298a192bef61cdeef0a2ec989afe72024dfccb08d5a0207739a71dd163e375dcdb7fba7d13bef431a851141decaf7 WHIRLPOOL f2d6e3347e007121edbaae1ecb78e5a23301d03eb2075737990bdca8157360ccb84e82b165617c00355553b9197df416b3bcfde4f15eb515e9db7032502e2756
DIST vmware-tools-windows-10.1.6-5214329.x86_64.component.tar 83640320 SHA256 fa12352507af0e097c9e8e6a0c638f93a3d5a3326b3218384438a58b8d0bd933 SHA512 040da7f2504ea77c0c3bd54a93f480d24752a0f5d29c40abe00e2d1d9e217f5a35d115a670fabbe2db5f36833f40d6cc8e28251fe745cc9bcc619e2c217aa7e2 WHIRLPOOL b80e049f9037aea47004983f3576939b00a52ed550d1c3864a6ed02d810542367ad6c10b993852b358de550e116fd9127e8cffa1844b47b6848781ef17937810

@ -0,0 +1,8 @@
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
<pkgmetadata>
<maintainer type="project">
<email>vmware@gentoo.org</email>
<name>Gentoo VMware Project</name>
</maintainer>
</pkgmetadata>

@ -0,0 +1,58 @@
# Copyright 1999-2016 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Id$
inherit versionator vmware-bundle
MY_PV="$(replace_version_separator 3 - $PV)"
BASE_URI="http://softwareupdate.vmware.com/cds/vmw-desktop/ws/12.5.6/5528349/linux/packages/"
DESCRIPTION="VMware Tools for guest operating systems"
HOMEPAGE="http://www.vmware.com/products/player/"
LICENSE="vmware"
SLOT="0"
KEYWORDS="-* ~amd64"
RESTRICT="mirror"
IUSE=""
DEPEND=""
RDEPEND=""
IUSE_VMWARE_GUEST="freebsd linux netware solaris windows winPre2k"
VM_INSTALL_DIR="/opt/vmware"
for guest in ${IUSE_VMWARE_GUEST} ; do
SRC_URI+=" vmware_guest_${guest}? (
amd64? ( ${BASE_URI}vmware-tools-${guest}-${MY_PV}.x86_64.component.tar )
)"
IUSE+=" vmware_guest_${guest}"
done ; unset guest
src_unpack() {
local arch
if use x86 ; then arch='i386'
elif use amd64 ; then arch='x86_64'
fi
local guest ; for guest in ${IUSE_VMWARE_GUEST} ; do
if use "vmware_guest_${guest}" ; then
local component="vmware-tools-${guest}-${MY_PV}.${arch}.component"
unpack "${component}.tar"
vmware-bundle_extract-component "${component}"
fi
done
}
src_install() {
insinto "${VM_INSTALL_DIR}"/lib/vmware/isoimages
local somethingdone;
local guest ; for guest in ${IUSE_VMWARE_GUEST} ; do
if use "vmware_guest_${guest}" ; then
doins "${guest}".iso{,.sig}
somethingdone=yes
fi
done
[ -n "${somethingdone}" ] || ewarn "You should set VMWARE_GUEST in make.conf to specify which operating systems you need."
}

@ -1,2 +1,3 @@
DIST VMware-Workstation-12.1.1-3770994.x86_64.bundle.tar 176445440 SHA256 a2c1888e6360245cf65fd19e86b7f74c63788e652145dc9a786aebbda0dd9e15 SHA512 55880e7aa6f7c968d82c88f36c1f406f587cccc9e25bdb9d1de1ffcfccb609811c525967bb2fefcf6375ce59f0f78d4dcc258c006b4a0db642dc3233e8fc9556 WHIRLPOOL 833eceedc1e9b7f3a0b73a039d1647faa9a5966a8a34e26c4955348092ebd9983f2f0ba2b8acb37805b339f492278916d06d68db7bb52a219126d7e78b02c469
DIST VMware-Workstation-12.5.6-5528349.x86_64.bundle.tar 165724160 SHA256 c7d5ecb72cb62f8d8538f581cff4513f7ede261671a1f6c50a54afa5d05fec39 SHA512 cce68510e01245aa8bf66dbb108121f1d94c69ba7fcc33b7fe9c16a40910a553fb4a43cbf5b5c5f0445bda90686568af56f28e16a3b321b760da3c084554359b WHIRLPOOL 06dc3de1665c8cd6ad54ad4c1678003e153e4f1dc14c831e5ee7350042c1ec80478565291ea099da1568878333c737b829d9124545322e7988ebc2c19accfd4d
DIST vmware-systemd-gentoo-02.tgz 14064 SHA256 7ab23cb41bb8fbeca43bfd3baee35928731177620ae374ebb3b19b827d1a3210 SHA512 3a382bfd5f1eb2b218d8012588ea55c1f22786dba35a1fc0fdfdb4e40b05e0e735ed09c6961684f6442e863c3ed72024ce01f19113bbd9ca47c32e3f43c55f42 WHIRLPOOL dd7ac934584894f4a0ae86a9122080c49a4d09924011bc12dc1530ac6b5ee11fac6d55d6e5b306bb24d749a509236d3e39870b4d6b2ff5de37f6e54707ff8bb6

@ -0,0 +1,92 @@
#!/sbin/openrc-run
# Copyright 1999-2014 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Id$
depend() {
need localmount
use net
}
start() {
ebegin Starting VMware USB Arbitrator
#start-stop-daemon --start --exec @@BINDIR@@/vmware-usbarbitrator
@@BINDIR@@/vmware-usbarbitrator
eend $?
ebegin Starting VMware services
# vmci might be:
# 1) built as external kernel module
# 2) built as internal kernel module (with name vmw_vmci)
# 3) embedded in the kernel
for mod in /lib/modules/$(uname -r)/misc/vmci.ko \
/lib/modules/$(uname -r)/kernel/drivers/misc/vmw_vmci/vmw_vmci.ko ;
do
if [[ -f "${mod}" ]] ; then
modprobe -v $(basename "${mod}" .ko)
eend $?
break
fi
done
# vsock might be:
# 1) built as external kernel module
# 2) built as internal kernel module (with name vmw_vsock_vmci_transport)
# 3) embedded in the kernel
for mod in /lib/modules/$(uname -r)/misc/vsock.ko \
/lib/modules/$(uname -r)/kernel/net/vmw_vsock/vmw_vsock_vmci_transport.ko ;
do
if [[ -f "${mod}" ]] ; then
modprobe -v $(basename "${mod}" .ko)
eend $?
break
fi
done
# vmci or vsock were already loaded by the previous modprobe,
# no need to do it here
modprobe -av vmmon vmblock vmnet
eend $?
@@BINDIR@@/vmware-networks --start
eend $?
}
stop() {
ebegin Stopping VMware USB Arbitrator
#start-stop-daemon --stop --exec @@BINDIR@@/vmware-usbarbitrator
killall --wait @@BINDIR@@/vmware-usbarbitrator
eend $?
@@BINDIR@@/vmware-networks --stop
eend $?
ebegin Stopping VMware services
modprobe -rv vmmon vmblock vmnet
eend $?
# vsock might be:
# 1) built as external kernel module
# 2) built as internal kernel module (with name vmw_vsock_vmci_transport)
# 3) embedded in the kernel
for mod in /lib/modules/$(uname -r)/misc/vsock.ko \
/lib/modules/$(uname -r)/kernel/net/vmw_vsock/vmw_vsock_vmci_transport.ko ;
do
if [[ -f "${mod}" ]] ; then
modprobe -rv $(basename "${mod}" .ko)
eend $?
break
fi
done
# vmci might be:
# 1) built as external kernel module
# 2) built as internal kernel module (with name vmw_vmci)
# 3) embedded in the kernel
for mod in /lib/modules/$(uname -r)/misc/vmci.ko \
/lib/modules/$(uname -r)/kernel/drivers/misc/vmw_vmci/vmw_vmci.ko ;
do
if [[ -f "${mod}" ]] ; then
modprobe -rv $(basename "${mod}" .ko)
eend $?
break
fi
done
}

@ -0,0 +1,55 @@
#!/sbin/openrc-run
# Copyright 1999-2013 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Id$
depend() {
need localmount vmware
use net
}
checkconfig() {
# Check if certificates exist. If not, we need to generate them, ala sshd.
if [ ! -e @@ETCDIR@@/ssl/rui.key -o ! -e @@ETCDIR@@/ssl/rui.crt ]; then
mkdir -p @@ETCDIR@@/ssl
openssl req -x509 -days 365 -newkey rsa:2048 -keyout @@ETCDIR@@/ssl/rui.key -out @@ETCDIR@@/ssl/rui.crt -config @@ETCDIR@@/ssl/hostd.ssl.config
chmod -R 600 @@ETCDIR@@/ssl
fi
}
start() {
checkconfig
ebegin Starting VMware Authentication Daemon
start-stop-daemon --start \
--exec @@PREFIX@@/sbin/vmware-authdlauncher
eend $?
ebegin Starting VMware Workstation Server
start-stop-daemon --start \
--pidfile /var/run/vmware/vmware-hostd.PID \
--exec @@BINDIR@@/vmware-hostd \
-- -a -d @@ETCDIR@@/hostd/config.xml
eend $?
}
stop() {
ebegin "Shutdown VMs in the AutoStart Sequence"
local HOHO_ADMIN="$(@@BINDIR@@/vmware-wssc-adminTool "@@ETCDIR@@/hostd/authorization.xml" 2>/dev/null)"
if [ "x" != "x${HOHO_ADMIN}" ]; then
@@BINDIR@@/vmware-vim-cmd -U "${HOHO_ADMIN}" hostsvc/autostartmanager/autostop
fi
eend $?
ebegin Stopping VMware Workstation Server
start-stop-daemon --stop \
--pidfile /var/run/vmware/vmware-hostd.PID \
--exec @@BINDIR@@/vmware-hostd
eend $?
ebegin Stopping VMware Authentication Daemon
#start-stop-daemon --stop \
# --exec @@PREFIX@@/sbin/vmware-authdlauncher
killall @@PREFIX@@/sbin/vmware-authdlauncher
eend $?
}

@ -0,0 +1,605 @@
# Copyright 1999-2016 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Id$
EAPI=5
inherit eutils versionator readme.gentoo-r1 fdo-mime gnome2-utils pam systemd vmware-bundle
MY_PN="VMware-Workstation"
MY_PV=$(get_version_component_range 1-3)
PV_MODULES="308.$(get_version_component_range 2-3)"
PV_BUILD=$(get_version_component_range 4)
MY_P="${MY_PN}-${MY_PV}-${PV_BUILD}"
SYSTEMD_UNITS_TAG="gentoo-02"
DESCRIPTION="Emulate a complete PC without the performance overhead of most emulators"
HOMEPAGE="http://www.vmware.com/products/workstation/"
BASE_URI="https://softwareupdate.vmware.com/cds/vmw-desktop/ws/${MY_PV}/${PV_BUILD}/linux/core/"
SRC_URI="
amd64? ( ${BASE_URI}${MY_P}.x86_64.bundle.tar )
https://github.com/akhuettel/systemd-vmware/archive/${SYSTEMD_UNITS_TAG}.tar.gz -> vmware-systemd-${SYSTEMD_UNITS_TAG}.tgz
"
LICENSE="vmware GPL-2 GPL-3"
SLOT="0"
KEYWORDS="-* ~amd64"
IUSE="bundled-libs cups doc ovftool server vix +vmware-tools"
RESTRICT="mirror strip"
BUNDLED_LIBS_DIR=/opt/vmware/lib/vmware/lib
BUNDLED_LIBS="
libXau.so.6
libXcomposite.so.1
libXcursor.so.1
libXdamage.so.1
libXdmcp.so.6
libXfixes.so.3
libXft.so.2
libXinerama.so.1
libXrandr.so.2
libXrender.so.1
libaio.so.1
libatk-1.0.so.0
libatkmm-1.6.so.1
libatspi.so.0
libcairo.so.2
libcairomm-1.0.so.1
libcrypto.so.1.0.1
libcurl.so.4
libdbus-1.so.3
libfontconfig.so.1
libfreetype.so.6
libfuse.so.2
libgailutil.so.18
libgcc_s.so.1
libgcrypt.so.11
libgdk-x11-2.0.so.0
libgdk_pixbuf-2.0.so.0
libgdkmm-2.4.so.1
libgio-2.0.so.0
libgiomm-2.4.so.1
libglib-2.0.so.0
libglibmm-2.4.so.1
libglibmm_generate_extra_defs-2.4.so.1
libgmodule-2.0.so.0
libgobject-2.0.so.0
libgpg-error.so.0
libgthread-2.0.so.0
libgtk-x11-2.0.so.0
libgtkmm-2.4.so.1
libpango-1.0.so.0
libpangocairo-1.0.so.0
libpangoft2-1.0.so.0
libpangomm-1.4.so.1
libpangox-1.0.so.0
libpangoxft-1.0.so.0
libpcsclite.so.1
libpixman-1.so.0
libpng12.so.0
librsvg-2.so.2
libsigc-2.0.so.0
libssl.so.1.0.1
libstdc++.so.6
libxml2.so.2
"
BUNDLED_LIB_DEPENDS="
dev-cpp/atkmm
dev-cpp/cairomm
dev-cpp/glibmm:2
dev-cpp/gtkmm:2.4
dev-cpp/pangomm
dev-libs/atk
dev-libs/glib:2
dev-libs/libgcrypt:11/11
dev-libs/libgpg-error
dev-libs/libsigc++:2
dev-libs/libxml2
dev-libs/openssl:0
media-libs/fontconfig
media-libs/freetype
media-libs/libpng:1.2
net-misc/curl
sys-fs/fuse
sys-libs/zlib
x11-libs/cairo
x11-libs/gdk-pixbuf:2
x11-libs/gtk+:2
x11-libs/libXau
x11-libs/libXcomposite
x11-libs/libXdamage
x11-libs/libXfixes
x11-libs/libXrandr
x11-libs/libXrender
x11-libs/pango
x11-libs/pixman
"
# vmware should not use virtual/libc as this is a
# precompiled binary package thats linked to glibc.
RDEPEND="
media-libs/alsa-lib
net-print/cups
x11-libs/libX11
x11-libs/libXcursor
x11-libs/libXext
x11-libs/libXi
x11-libs/libXinerama
x11-libs/libXtst
x11-libs/startup-notification
x11-themes/hicolor-icon-theme
bundled-libs? (
media-libs/tiff:3
x11-libs/libICE
x11-libs/libSM
virtual/jpeg:62
)
!bundled-libs? ( ${BUNDLED_LIB_DEPENDS} )
!app-emulation/vmware-player
"
PDEPEND="~app-emulation/vmware-modules-${PV_MODULES}
vmware-tools? ( app-emulation/vmware-tools )"
DEPEND=">=dev-util/patchelf-0.9"
S=${WORKDIR}
VM_INSTALL_DIR="/opt/vmware"
VM_DATA_STORE_DIR="/var/lib/vmware/Shared VMs"
VM_HOSTD_USER="root"
QA_PREBUILT="/opt/*"
QA_WX_LOAD="opt/vmware/lib/vmware/tools-upgraders/vmware-tools-upgrader-32 opt/vmware/lib/vmware/bin/vmware-vmx-stats opt/vmware/lib/vmware/bin/vmware-vmx-debug opt/vmware/lib/vmware/bin/vmware-vmx"
src_unpack() {
default
local bundle=${MY_P}.x86_64.bundle
local component; for component in \
vmware-workstation \
vmware-player-app \
vmware-player-setup \
vmware-vmx \
vmware-network-editor \
vmware-network-editor-ui \
vmware-usbarbitrator \
vmware-vprobe
do
vmware-bundle_extract-bundle-component "${bundle}" "${component}" "${S}"
done
if use ovftool; then
vmware-bundle_extract-bundle-component "${bundle}" vmware-ovftool
fi
if use server; then
vmware-bundle_extract-bundle-component "${bundle}" vmware-workstation-server #"${S}"
fi
if use vix; then
vmware-bundle_extract-bundle-component "${bundle}" vmware-vix-core vmware-vix
vmware-bundle_extract-bundle-component "${bundle}" vmware-vix-lib-Workstation1200 vmware-vix
fi
}
clean_bundled_libs() {
if ! use bundled-libs ; then
einfo "Removing bundled libraries"
for libname in ${BUNDLED_LIBS} ; do
rm -rv "${S}"/lib/lib/${libname} || die "Failed removing bundled ${libname}"
done
rm -rv "${S}"/lib/libconf || die "Failed removing bundled gtk conf libs"
# Among the bundled libs there are libcrypto.so.1.0.1 and libssl.so.1.0.1
# (needed by libcds.so) which seem to be compiled from openssl-1.0.1h.
# Upstream real sonames are *so.1.0.0 so it's necessary to fix DT_NEEDED link
# in libcds.so to be able to use system libs.
pushd >/dev/null .
einfo "Patching libcds.so"
cd "${S}"/lib/lib/libcds.so || die
patchelf --replace-needed libssl.so.1.0.{1,0} \
--replace-needed libcrypto.so.1.0.{1,0} \
libcds.so || die
popd >/dev/null
# vmware-workstation seems to use a custom version of libgksu2.so, for this reason
# we leave the bundled version. The libvmware-gksu.so library declares simply DT_NEEDED
# libgksu2.so.0 but it uses at runtime the bundled version, patch the lib to avoid portage
# preserve-libs mechanism to be triggered when a system lib is available (but not required)
pushd >/dev/null .
einfo "Patching libvmware-gksu.so"
cd "${S}"/lib/lib/libvmware-gksu.so || die
patchelf --set-rpath "\$ORIGIN/../libgksu2.so.0" \
libvmware-gksu.so || die
popd >/dev/null
else
# if librsvg is not installed in the system then vmware doesn't start
pushd >/dev/null .
einfo "Patching svg_loader.so"
cd "${S}"/lib/libconf/lib/gtk-2.0/2.10.0/loaders || die
patchelf --set-rpath "\$ORIGIN/../../../../../lib/librsvg-2.so.2" \
svg_loader.so || die
popd >/dev/null
fi
}
src_prepare() {
rm -f bin/vmware-modconfig
rm -rf lib/modules/binary
# Bug 459566
mv lib/libvmware-netcfg.so lib/lib/
if use server; then
rm -f vmware-workstation-server/bin/{openssl,configure-hostd.sh}
fi
clean_bundled_libs
DOC_CONTENTS="
/etc/env.d is updated during ${PN} installation. Please run:\n
env-update && source /etc/profile\n
Before you can use ${PN}, you must configure a default network setup.
You can do this by running 'emerge --config ${PN}'.\n
To be able to run ${PN} your user must be in the vmware group.\n
You MUST set USE=bundled-libs if you are running gcc-5, otherwise vmware will not start.
"
}
src_install() {
local major_minor=$(get_version_component_range 1-2 "${PV}")
# revdep-rebuild entry
insinto /etc/revdep-rebuild
echo "SEARCH_DIRS_MASK=\"${VM_INSTALL_DIR}\"" >> ${T}/10${PN}
doins "${T}"/10${PN}
# install the binaries
into "${VM_INSTALL_DIR}"
dobin bin/*
# install the libraries
insinto "${VM_INSTALL_DIR}"/lib/vmware
doins -r lib/*
# workaround for hardcoded search paths needed during shared objects loading
if ! use bundled-libs ; then
dosym /usr/$(get_libdir)/libglib-2.0.so.0 \
"${VM_INSTALL_DIR}"/lib/vmware/lib/libglib-2.0.so.0/libglib-2.0.so.0
# Bug 432918
dosym /usr/$(get_libdir)/libcrypto.so.1.0.0 \
"${VM_INSTALL_DIR}"/lib/vmware/lib/libcrypto.so.1.0.1/libcrypto.so.1.0.1
dosym /usr/$(get_libdir)/libssl.so.1.0.0 \
"${VM_INSTALL_DIR}"/lib/vmware/lib/libssl.so.1.0.1/libssl.so.1.0.1
fi
# bug 616958
# system libs don't work anymore with embedeed zlib because it doesn't support ZLIB_1.2.9,
# add this hack to bypass embedded zlib which is always loaded and required during startup
# of vmware since 12.5.x
dosym /$(get_libdir)/libz.so.1 \
"${VM_INSTALL_DIR}"/lib/vmware/lib/libz.so.1/libz.so.1
# install the ancillaries
insinto /usr
doins -r share
if use cups; then
exeinto $(cups-config --serverbin)/filter
doexe extras/thnucups
insinto /etc/cups
doins -r etc/cups/*
fi
if use doc; then
dodoc doc/*
fi
exeinto "${VM_INSTALL_DIR}"/lib/vmware/setup
doexe vmware-config
# install vmware workstation server
if use server; then
dosbin sbin/*
cd "${S}"/vmware-workstation-server
# install binaries
into "${VM_INSTALL_DIR}"/lib/vmware
dobin bin/*
dobin "${FILESDIR}"/configure-hostd.sh
dobin "${FILESDIR}"/configure-hostd.sh
# install the libraries
insinto "${VM_INSTALL_DIR}"/lib/vmware/lib
doins -r lib/*
into "${VM_INSTALL_DIR}"
for tool in vmware-hostd wssc-adminTool ; do
cat > "${T}/${tool}" <<-EOF
#!/usr/bin/env bash
set -e
. /etc/vmware/bootstrap
exec "${VM_INSTALL_DIR}/lib/vmware/lib/wrapper-gtk24.sh" \\
"${VM_INSTALL_DIR}/lib/vmware/lib" \\
"${VM_INSTALL_DIR}/lib/vmware/bin/${tool}" \\
"${VM_INSTALL_DIR}/lib/vmware/libconf" "\$@"
EOF
dobin "${T}/${tool}"
done
insinto "${VM_INSTALL_DIR}"/lib/vmware
doins -r hostd
# create the configuration
insinto /etc/vmware/hostd
doins -r config/etc/vmware/hostd/*
doins -r etc/vmware/hostd/*
insinto /etc/vmware/ssl
doins etc/vmware/ssl/*
# pam
pamd_mimic_system vmware-authd auth account
# create directory for shared virtual machines.
keepdir "${VM_DATA_STORE_DIR}"
keepdir /var/log/vmware
fi
# install vmware-vix
if use vix; then
cd "${S}"/vmware-vix
# install the binary
into "${VM_INSTALL_DIR}"
dobin bin/*
# install the libraries
insinto "${VM_INSTALL_DIR}"/lib/vmware-vix
doins -r lib/*
dosym vmware-vix/libvixAllProducts.so "${VM_INSTALL_DIR}"/lib/libbvixAllProducts.so
# install headers
insinto /usr/include/vmware-vix
doins include/*
if use doc; then
dohtml -r doc/*
fi
fi
# install ovftool
if use ovftool; then
cd "${S}"
insinto "${VM_INSTALL_DIR}"/lib/vmware-ovftool
doins -r vmware-ovftool/*
chmod 0755 "${D}${VM_INSTALL_DIR}"/lib/vmware-ovftool/{ovftool,ovftool.bin}
dosym "${D}${VM_INSTALL_DIR}"/lib/vmware-ovftool/ovftool "${VM_INSTALL_DIR}"/bin/ovftool
fi
# create symlinks for the various tools
local tool ; for tool in thnuclnt vmware vmplayer{,-daemon} licenseTool vmamqpd \
vmware-{acetool,enter-serial,gksu,fuseUI,modconfig{,-console},netcfg,tray,zenity} ; do
dosym appLoader "${VM_INSTALL_DIR}"/lib/vmware/bin/"${tool}"
done
dosym "${VM_INSTALL_DIR}"/lib/vmware/bin/vmplayer "${VM_INSTALL_DIR}"/bin/vmplayer
dosym "${VM_INSTALL_DIR}"/lib/vmware/bin/vmware "${VM_INSTALL_DIR}"/bin/vmware
dosym "${VM_INSTALL_DIR}"/lib/vmware/icu /etc/vmware/icu
# fix permissions
fperms 0755 "${VM_INSTALL_DIR}"/lib/vmware/bin/{appLoader,fusermount,launcher.sh,mkisofs,vmware-remotemks}
fperms 0755 "${VM_INSTALL_DIR}"/lib/vmware/lib/wrapper-gtk24.sh
fperms 0755 "${VM_INSTALL_DIR}"/lib/vmware/lib/libgksu2.so.0/gksu-run-helper
fperms 0755 "${VM_INSTALL_DIR}"/lib/vmware/setup/vmware-config
fperms 4711 "${VM_INSTALL_DIR}"/bin/vmware-mount
fperms 4711 "${VM_INSTALL_DIR}"/lib/vmware/bin/vmware-vmx{,-debug,-stats}
if use server; then
fperms 0755 "${VM_INSTALL_DIR}"/lib/vmware/bin/{vmware-hostd,wssc-adminTool}
fperms 4711 "${VM_INSTALL_DIR}"/sbin/vmware-authd
fperms 1777 "${VM_DATA_STORE_DIR}"
fi
if use vix; then
fperms 0755 "${VM_INSTALL_DIR}"/lib/vmware-vix/setup/vmware-config
fi
# create the environment
local envd="${T}/90vmware"
cat > "${envd}" <<-EOF
PATH='${VM_INSTALL_DIR}/bin'
ROOTPATH='${VM_INSTALL_DIR}/bin'
EOF
use bundled-libs && echo 'VMWARE_USE_SHIPPED_LIBS=1' >> "${envd}"
doenvd "${envd}"
# create the configuration
dodir /etc/vmware
cat > "${D}"/etc/vmware/bootstrap <<-EOF
BINDIR='${VM_INSTALL_DIR}/bin'
LIBDIR='${VM_INSTALL_DIR}/lib'
EOF
cat > "${D}"/etc/vmware/config <<-EOF
bindir = "${VM_INSTALL_DIR}/bin"
libdir = "${VM_INSTALL_DIR}/lib/vmware"
initscriptdir = "/etc/init.d"
authd.fullpath = "${VM_INSTALL_DIR}/sbin/vmware-authd"
gksu.rootMethod = "su"
VMCI_CONFED = "yes"
VMBLOCK_CONFED = "yes"
VSOCK_CONFED = "yes"
NETWORKING = "yes"
player.product.version = "${MY_PV}"
product.buildNumber = "${PV_BUILD}"
product.version = "${MY_PV}"
product.name = "VMware Workstation"
workstation.product.version = "${MY_PV}"
EOF
if use vix; then
cat >> "${D}"/etc/vmware/config <<-EOF
vmware.fullpath = "${VM_INSTALL_DIR}/bin/vmware"
vix.libdir = "${VM_INSTALL_DIR}/lib/vmware-vix"
vix.config.version = "1"
EOF
fi
if use server; then
cat >> "${D}"/etc/vmware/config <<-EOF
authd.client.port = "902"
authd.proxy.nfc = "vmware-hostd:ha-nfc"
authd.soapserver = "TRUE"
EOF
fi
# install the init.d script
local initscript="${T}/vmware.rc"
sed -e "s:@@BINDIR@@:${VM_INSTALL_DIR}/bin:g" \
"${FILESDIR}/vmware-${major_minor}.rc" > "${initscript}" || die
newinitd "${initscript}" vmware
if use server; then
# install the init.d script
local initscript="${T}/vmware-workstation-server.rc"
sed -e "s:@@ETCDIR@@:/etc/vmware:g" \
-e "s:@@PREFIX@@:${VM_INSTALL_DIR}:g" \
-e "s:@@BINDIR@@:${VM_INSTALL_DIR}/bin:g" \
-e "s:@@LIBDIR@@:${VM_INSTALL_DIR}/lib/vmware:g" \
"${FILESDIR}/vmware-server-${major_minor}.rc" > ${initscript} || die
newinitd "${initscript}" vmware-workstation-server
fi
# fill in variable placeholders
if use bundled-libs ; then
sed -e "s:@@LIBCONF_DIR@@:${VM_INSTALL_DIR}/lib/vmware/libconf:g" \
-i "${D}${VM_INSTALL_DIR}"/lib/vmware/libconf/etc/{gtk-2.0/{gdk-pixbuf.loaders,gtk.immodules},pango/pango{.modules,rc}} || die
fi
sed -e "s:@@BINARY@@:${VM_INSTALL_DIR}/bin/vmplayer:g" \
-e "/^Encoding/d" \
-i "${D}/usr/share/applications/vmware-player.desktop" || die
sed -e "s:@@BINARY@@:${VM_INSTALL_DIR}/bin/vmware:g" \
-e "/^Encoding/d" \
-i "${D}/usr/share/applications/vmware-workstation.desktop" || die
sed -e "s:@@BINARY@@:${VM_INSTALL_DIR}/bin/vmware-netcfg:g" \
-e "/^Encoding/d" \
-i "${D}/usr/share/applications/vmware-netcfg.desktop" || die
if use server; then
# Configuration for vmware-workstation-server
local hostdUser="${VM_HOSTD_USER:-root}"
sed -e "/ACEDataUser/s:root:${hostdUser}:g" \
-i "${D}/etc/vmware/hostd/authorization.xml" || die
# Shared VMs Path: [standard].
sed -e "s:##{DS_NAME}##:standard:g" \
-e "s:##{DS_PATH}##:${VM_DATA_STORE_DIR}:g" \
-i "${D}/etc/vmware/hostd/datastores.xml" || die
sed -e "s:##{HTTP_PORT}##:-1:g" \
-e "s:##{HTTPS_PORT}##:443:g" \
-e "s:##{PIPE_PREFIX}##:/var/run/vmware/:g" \
-i "${D}/etc/vmware/hostd/proxy.xml" || die
# See vmware-workstation-server.py for more details.
sed -e "s:##{BUILD_CFGDIR}##:/etc/vmware/hostd/:g" \
-e "s:##{CFGALTDIR}##:/etc/vmware/hostd/:g" \
-e "s:##{CFGDIR}##:/etc/vmware/:g" \
-e "s:##{ENABLE_AUTH}##:true:g" \
-e "s:##{HOSTDMODE}##:ws:g" \
-e "s:##{HOSTD_CFGDIR}##:/etc/vmware/hostd/:g" \
-e "s:##{HOSTD_MOCKUP}##:false:g" \
-e "s:##{LIBDIR}##:${VM_INSTALL_DIR}/lib/vmware:g" \
-e "s:##{LIBDIR_INSTALLED}##:${VM_INSTALL_DIR}/lib/vmware/:g" \
-e "s:##{LOGDIR}##:/var/log/vmware/:g" \
-e "s:##{LOGLEVEL}##:verbose:g" \
-e "s:##{MOCKUP}##:mockup-host-config.xml:g" \
-e "s:##{PLUGINDIR}##:./:g" \
-e "s:##{SHLIB_PREFIX}##:lib:g" \
-e "s:##{SHLIB_SUFFIX}##:.so:g" \
-e "s:##{USE_BLKLISTSVC}##:false:g" \
-e "s:##{USE_CBRCSVC}##:false:g" \
-e "s:##{USE_CIMSVC}##:false:g" \
-e "s:##{USE_DIRECTORYSVC}##:false:g" \
-e "s:##{USE_DIRECTORYSVC_MOCKUP}##:false:g" \
-e "s:##{USE_DYNAMIC_PLUGIN_LOADING}##:false:g" \
-e "s:##{USE_DYNAMO}##:false:g" \
-e "s:##{USE_DYNSVC}##:false:g" \
-e "s:##{USE_GUESTSVC}##:false:g" \
-e "s:##{USE_HBRSVC}##:false:g" \
-e "s:##{USE_HBRSVC_MOCKUP}##:false:g" \
-e "s:##{USE_HOSTSVC_MOCKUP}##:false:g" \
-e "s:##{USE_HTTPNFCSVC}##:false:g" \
-e "s:##{USE_HTTPNFCSVC_MOCKUP}##:false:g" \
-e "s:##{USE_LICENSESVC_MOCKUP}##:false:g" \
-e "s:##{USE_NFCSVC}##:true:g" \
-e "s:##{USE_NFCSVC_MOCKUP}##:false:g" \
-e "s:##{USE_OVFMGRSVC}##:true:g" \
-e "s:##{USE_PARTITIONSVC}##:false:g" \
-e "s:##{USE_SECURESOAP}##:false:g" \
-e "s:##{USE_SNMPSVC}##:false:g" \
-e "s:##{USE_SOLO_MOCKUP}##:false:g" \
-e "s:##{USE_STATSSVC_MOCKUP}##:false:g" \
-e "s:##{USE_VCSVC_MOCKUP}##:false:g" \
-e "s:##{USE_VDISKSVC}##:false:g" \
-e "s:##{USE_VDISKSVC_MOCKUP}##:false:g" \
-e "s:##{USE_VMSVC_MOCKUP}##:false:g" \
-e "s:##{VM_INVENTORY}##:vmInventory.xml:g" \
-e "s:##{VM_RESOURCES}##:vmResources.xml:g" \
-e "s:##{WEBSERVER_PORT_ENTRY}##::g" \
-e "s:##{WORKINGDIR}##:./:g" \
-i "${D}/etc/vmware/hostd/config.xml" || die
sed -e "s:##{ENV_LOCATION}##:/etc/vmware/hostd/env/:g" \
-i "${D}/etc/vmware/hostd/environments.xml" || die
# @@VICLIENT_URL@@=XXX
sed -e "s:@@AUTHD_PORT@@:902:g" \
-i "${D}${VM_INSTALL_DIR}/lib/vmware/hostd/docroot/client/clients.xml" || die
fi
# install systemd unit files
systemd_dounit "${WORKDIR}/systemd-vmware-${SYSTEMD_UNITS_TAG}/"*.{service,target}
readme.gentoo_create_doc
}
pkg_config() {
"${VM_INSTALL_DIR}"/bin/vmware-networks --postinstall ${PN},old,new
}
pkg_preinst() {
gnome2_icon_savelist
}
pkg_postinst() {
fdo-mime_desktop_database_update
gnome2_icon_cache_update
readme.gentoo_print_elog
ewarn "${P} is using an old version of libgcrypt library which"
ewarn "is going to be soon removed from portage due to security reasons"
ewarn "(see https://bugs.gentoo.org/show_bug.cgi?id=541564)."
ewarn "Until vmware is fixed upstream you're exposed to security issues!"
}
pkg_prerm() {
einfo "Stopping ${PN} for safe unmerge"
/etc/init.d/vmware stop
}
pkg_postrm() {
fdo-mime_desktop_database_update
gnome2_icon_cache_update
}
Loading…
Cancel
Save